

import java.awt.*;
import java.awt.image.*;
import java.awt.color.*;
import java.io.*;
import javax.imageio.*;
import javax.swing.*;


public class Test1 {
    public static void case2(BufferedImage img) {
	int w = 30;
	int p;
	Color c;
	for (int n=0; n<12; n++) {
		p = img.getRGB(15+w*n,60);
		c = new Color(p);
		System.out.format("pixel %x%n",p);		
		System.out.println(c);
	}
    }
    public static void case1(BufferedImage img) {
	int w = 120;
	int p;
	Color c;
	for (int n=0; n<3; n++) {
		p = img.getRGB(60+w*n,60);
		c = new Color(p);
		System.out.format("pixel %x  %d%n",p, p&0xFF);		
		System.out.println(c);
	}
    }

    public static void main(String[] args) {

	int ncase = args.length>0? Integer.parseInt(args[0]): 0;
	String [] filenames = {"test.png", "test2.png"};
	String filename = args.length>1? args[1]: filenames[ncase];

	ImageFrame f1 = new ImageFrame(filename);
	f1.setLocation(100,100);
	f1.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	int w = f1.getWidth();
	int h = f1.getHeight();

	ColorConvertOp op = new ColorConvertOp(ColorSpace.getInstance(ColorSpace.CS_GRAY), null);
	long start = System.nanoTime();
	BufferedImage grayImage = op.filter(f1.img, null);
	long etime = System.nanoTime() - start;
	double elapsed_time = 1e-6*(double)etime;
	System.out.format("Elapsed time %g milliseconds%n",elapsed_time);
	double area = f1.img.getWidth()*f1.img.getHeight()*1e-6;
	System.out.format("%d x %d Area %g megapixels%n",f1.img.getWidth(),
		f1.img.getHeight(), area);
	System.out.format("Time per megapixel %g milliseconds%n",elapsed_time/area);	

	ImageFrame f2 = new ImageFrame(grayImage,"gray version");
	f2.setLocation(120+w,100);
	if (ncase==0) case1(grayImage);
	else if (ncase==1) case2(grayImage);
	f2.writeImage("gray","png");	
    }
}
	


